
#include "terasic_includes.h"
#include "mem_verify.h"


#define STATUS_BIT_DONE 	0x01
#define STATUS_BIT_FAIL 	0x02
#define STATUS_BIT_SUCCESS 	0x04

int main()
{
	bool bPass;
	alt_u32 InitValue = 0x01;
	bool bShowMessage = TRUE;
	alt_u32 TimeStart, TimeElapsed;
	alt_u8 Status;


	printf("===== DDR3 Test! Size=%dM (CPU Clock:%d)=====\r\n", MEM_IF_DDR3_EMIF_SPAN/1024/1024, ALT_CPU_CPU_FREQ);
	Status = IORD(DDR3_STATUS_BASE, 0x00);

	if ((Status & STATUS_BIT_DONE) != STATUS_BIT_DONE){
		printf("local init done: fail\r\n");
		return 0;
	}

	if (((Status & STATUS_BIT_FAIL) == STATUS_BIT_FAIL) || ((Status & STATUS_BIT_SUCCESS) != STATUS_BIT_SUCCESS)){
		printf("local init: fail\r\n");
		return 0;
	}


	TimeStart = alt_nticks();
	bPass = TMEM_Verify(MEM_IF_DDR3_EMIF_BASE, MEM_IF_DDR3_EMIF_SPAN, InitValue,  bShowMessage);
	TimeElapsed = alt_nticks() - TimeStart;
	printf("test:%s, %d seconds\r\n", bPass?"Pass":"NG", (int)(TimeElapsed/alt_ticks_per_second()));

    return 0;
}
