// ============================================================================
// Copyright (c) 2013 by Terasic Technologies Inc.
// ============================================================================
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// ============================================================================
//           
//  Terasic Technologies Inc
//  9F., No.176, Sec.2, Gongdao 5th Rd, East Dist, Hsinchu City, 30070. Taiwan
//  
//  
//                     web: http://www.terasic.com/  
//                     email: support@terasic.com
//
// ============================================================================
//Date:  Mon Dec 23 16:51:25 2013
// ============================================================================
// ============================================================================
//
// Major Functions:	TR5-LITE QDRII x4 RTL  test
// ============================================================================
//
// Revision History :
// ============================================================================
//   Ver  :| Author            :| Mod. Date  :| Changes Made:
//   V1.0 :| Richard,Dee Zeng  :| 2012/02/15 :| Initial Revision
//   V2.0 :| XinXian           :| 13/12/30   :| Update to Q13.1 for TR5_Lite_revB
// ============================================================================

//`define ENABLE_DDR3A
//`define ENABLE_DDR3B
`define ENABLE_QDRII
//`define ENABLE_SFP
//`define ENABLE_PCIE
//`define ENABLE_SATA

module TR5_Lite_QDRIIx4_Test(

      ///////// BUTTON /////////
      input       [1:0]  BUTTON,

      ///////// CLK /////////
      output             CLK_CE,
      output      [2:0]  CLK_OD,
      output      [1:0]  CLK_OS,
      output      [1:0]  CLK_PR,
      output             CLK_RST_n,

      ///////// CLOCK /////////
      output             CLOCK_SCL,
      inout              CLOCK_SDA,

      ///////// CPU /////////
      input              CPU_RESET_n,

`ifdef ENABLE_DDR3A
      ///////// DDR3A /////////
      output      [15:0] DDR3A_A,
      output      [2:0]  DDR3A_BA,
      output             DDR3A_CAS_n,
      output             DDR3A_CK,
      output      [1:0]  DDR3A_CKE,
      output             DDR3A_CK_n,
      output      [1:0]  DDR3A_CS_n,
      output      [1:0]  DDR3A_DM,
      inout       [15:0] DDR3A_DQ,
      inout       [1:0]  DDR3A_DQS,
      inout       [1:0]  DDR3A_DQS_n,
      output      [1:0]  DDR3A_ODT,
      output             DDR3A_RAS_n,
      output             DDR3A_RESET_n,
      output             DDR3A_WE_n,
`endif /*ENABLE_DDR3A*/

`ifdef ENABLE_DDR3B
      ///////// DDR3B /////////
      output      [15:0] DDR3B_A,
      output      [2:0]  DDR3B_BA,
      output             DDR3B_CAS_n,
      output             DDR3B_CK,
      output      [1:0]  DDR3B_CKE,
      output             DDR3B_CK_n,
      output      [1:0]  DDR3B_CS_n,
      output      [1:0]  DDR3B_DM,
      inout       [15:0] DDR3B_DQ,
      inout       [1:0]  DDR3B_DQS,
      inout       [1:0]  DDR3B_DQS_n,
      output      [1:0]  DDR3B_ODT,
      output             DDR3B_RAS_n,
      output             DDR3B_RESET_n,
      output             DDR3B_WE_n,
`endif /*ENABLE_DDR3B*/

      ///////// FAN /////////
      inout              FAN_CTRL,

      ///////// FLASH /////////
      output             FLASH_ADV_n,
      output      [1:0]  FLASH_CE_n,
      output             FLASH_CLK,
      output             FLASH_OE_n,
      input       [1:0]  FLASH_RDY_BSY_n,
      output             FLASH_RESET_n,
      output             FLASH_WE_n,

      ///////// FSM /////////
      output      [26:0] FSM_A,
      inout       [31:0] FSM_D,

      ///////// LED /////////
      output      [3:0]  LED,
      output      [3:0]  LED_BRACKET,

      ///////// OSC /////////
      input              OSC_50_B3B,
      input              OSC_50_B3D,
      input              OSC_50_B4A,
      input              OSC_50_B4D,
      input              OSC_50_B7A,
      input              OSC_50_B7D,
      input              OSC_50_B8A,
      input              OSC_50_B8D,

`ifdef ENABLE_PCIE
      ///////// PCIE /////////
      input              PCIE_PERST_n,
      input              PCIE_REFCLK_p,
      input       [7:0]  PCIE_RX_p,
      input              PCIE_SMBCLK,
      inout              PCIE_SMBDAT,
      output      [7:0]  PCIE_TX_p,
      output             PCIE_WAKE_n,
`endif /*ENABLE_PCIE*/

`ifdef ENABLE_QDRII
      ///////// QDRIIA /////////
      output      [20:0] QDRIIA_A,
      output      [1:0]  QDRIIA_BWS_n,
      input              QDRIIA_CQ_n,
      input              QDRIIA_CQ_p,
      output      [17:0] QDRIIA_D,
      output             QDRIIA_DOFF_n,
      output             QDRIIA_K_n,
      output             QDRIIA_K_p,
      output             QDRIIA_ODT,
      input       [17:0] QDRIIA_Q,
      input              QDRIIA_QVLD,
      output             QDRIIA_RPS_n,
      output             QDRIIA_WPS_n,

      ///////// QDRIIB /////////
      output      [20:0] QDRIIB_A,
      output      [1:0]  QDRIIB_BWS_n,
      input              QDRIIB_CQ_n,
      input              QDRIIB_CQ_p,
      output      [17:0] QDRIIB_D,
      output             QDRIIB_DOFF_n,
      output             QDRIIB_K_n,
      output             QDRIIB_K_p,
      output             QDRIIB_ODT,
      input       [17:0] QDRIIB_Q,
      input              QDRIIB_QVLD,
      output             QDRIIB_RPS_n,
      output             QDRIIB_WPS_n,

      ///////// QDRIIC /////////
      output      [20:0] QDRIIC_A,
      output      [1:0]  QDRIIC_BWS_n,
      input              QDRIIC_CQ_n,
      input              QDRIIC_CQ_p,
      output      [17:0] QDRIIC_D,
      output             QDRIIC_DOFF_n,
      output             QDRIIC_K_n,
      output             QDRIIC_K_p,
      output             QDRIIC_ODT,
      input       [17:0] QDRIIC_Q,
      input              QDRIIC_QVLD,
      output             QDRIIC_RPS_n,
      output             QDRIIC_WPS_n,

      ///////// QDRIID /////////
      output      [20:0] QDRIID_A,
      output      [1:0]  QDRIID_BWS_n,
      input              QDRIID_CQ_n,
      input              QDRIID_CQ_p,
      output      [17:0] QDRIID_D,
      output             QDRIID_DOFF_n,
      output             QDRIID_K_n,
      output             QDRIID_K_p,
      output             QDRIID_ODT,
      input       [17:0] QDRIID_Q,
      input              QDRIID_QVLD,
      output             QDRIID_RPS_n,
      output             QDRIID_WPS_n,
`endif //ENABLE_QDRII
		
      ///////// RZQ /////////
      input              RZQ_0,
      input              RZQ_1,
      input              RZQ_4,
      input              RZQ_5,


      ///////// RS422 /////////
      output             RS422_DE,
      input              RS422_DIN,
      output             RS422_DOUT,
      output             RS422_RE_n,
      output             RS422_TE,

`ifdef ENABLE_SATA
      ///////// SATA /////////
      input              SATA_HOST_RX_p,
      output             SATA_HOST_TX_p,
      input              SATA_REFCLK_p,
`endif /*ENABLE_SATA*/

`ifdef ENABLE_SFP
      ///////// SFPA /////////
      input              SFPA_LOS,
      input              SFPA_MOD0_PRSNT_n,
      output             SFPA_MOD1_SCL,
      inout              SFPA_MOD2_SDA,
      output      [1:0]  SFPA_RATESEL,
      input              SFPA_RX_p,
      output             SFPA_TXDISABLE,
      input              SFPA_TXFAULT,
      output             SFPA_TX_p,

      ///////// SFPB /////////
      input              SFPB_LOS,
      input              SFPB_MOD0_PRSNT_n,
      output             SFPB_MOD1_SCL,
      inout              SFPB_MOD2_SDA,
      output      [1:0]  SFPB_RATESEL,
      input              SFPB_RX_p,
      output             SFPB_TXDISABLE,
      input              SFPB_TXFAULT,
      output             SFPB_TX_p,

      ///////// SFP /////////
      input              SFP_REFCLK_p,
`endif /*ENABLE_SFP*/

      ///////// SW /////////
      input       [1:0]  SW,

      ///////// TEMP /////////
      output             TEMP_CLK,
      inout              TEMP_DATA,
      input              TEMP_INT_n,
      input              TEMP_OVERT_n
);


//=======================================================
//  REG/WIRE declarations
//=======================================================

assign FAN_CTRL = 1'b1;	

//=======================================================
//  Structural coding
//=======================================================

////////QDRII  x4 ////////////
//in this case qdrii_slave shares pll & dll & oct from qdrii_master
//qdriix4 Architecture: one master,three slave | C : master -A B D : slave 
//clock source use OSC_50_B8D

wire afi_clk; // clock for test controller
/// test status ..
// QDRII+ Verify	(A)
wire qdriia_pass;
wire qdriia_fail;
wire qdriia_test_complete;
wire qdriia_local_init_done;
wire qdriia_local_cal_success;
wire qdriia_local_cal_fail;
// QDRII+ Verify	(B)
wire qdriib_pass;
wire qdriib_fail;
wire qdriib_test_complete;
wire qdriib_local_init_done;
wire qdriib_local_cal_success;
wire qdriib_local_cal_fail;
// QDRII+ Verify	(C)
wire qdriic_pass;
wire qdriic_fail;
wire qdriic_test_complete;
wire qdriic_local_init_done;
wire qdriic_local_cal_success;
wire qdriic_local_cal_fail;
// QDRII+ Verify	(D)
wire qdriid_pass;
wire qdriid_fail;
wire qdriid_test_complete;
wire qdriid_local_init_done;
wire qdriid_local_cal_success;
wire qdriid_local_cal_fail;

QDRII_x4 QDRII_A_B_C_D(
		.pll_ref_clk(OSC_50_B8D),                       	  // pll_ref_clk.clk
		.global_reset_n(test_global_reset_n),           	  // global_reset.reset_n
		.soft_reset_n(test_software_reset_n),           	  // soft_reset.reset_n		
		.oct_rzqin(RZQ_4),                						  // oct.rzqin
     
	  //here for avalon_bus_RW_Test 	
      .afi_clk(afi_clk),                    					  // afi_clk_in.clk
		.afi_half_clk(),                                	  // afi_half_clk_in.clk
		.afi_reset_n(),                                 	  // afi_reset_in.reset_n
		
	// QDRII+ SRAM (A) 
		.qdriia_mem_cq_n(QDRIIA_CQ_n),                  	  // memory.mem_cq_n
		.qdriia_mem_wps_n(QDRIIA_WPS_n),                	  //.mem_wps_n
		.qdriia_mem_cq(QDRIIA_CQ_p),                    	  //.mem_cq
		.qdriia_mem_rps_n(QDRIIA_RPS_n),                	  //.mem_rps_n
		.qdriia_mem_a(QDRIIA_A),                        	  //.mem_a
		.qdriia_mem_d(QDRIIA_D),                        	  //.mem_d
		.qdriia_mem_k_n(QDRIIA_K_n),                    	  //.mem_k_n
		.qdriia_mem_bws_n(QDRIIA_BWS_n),                	  //.mem_bws_n
		.qdriia_mem_q(QDRIIA_Q),                        	  //.mem_q
		.qdriia_mem_k(QDRIIA_K_p),                      	  //.mem_k
		.qdriia_mem_doff_n(QDRIIA_DOFF_n),              	  //.mem_doff_n
		
		.qdriia_avl_w_write_req(qdriia_avl_w_write_req),     // avl_w.write
		.qdriia_avl_w_ready(qdriia_avl_w_ready),       		  //.waitrequest_n
		.qdriia_avl_w_addr(qdriia_avl_w_addr),        		  //.address
		.qdriia_avl_w_size(qdriia_avl_w_size),        		  //.burstcount
		.qdriia_avl_w_wdata(qdriia_avl_w_wdata),       		  //.writedata
		.qdriia_avl_r_read_req(qdriia_avl_r_read_req),    	  // avl_r.read
		.qdriia_avl_r_ready(qdriia_avl_r_ready),       		  //.waitrequest_n
		.qdriia_avl_r_addr(qdriia_avl_r_addr),        		  //.address
		.qdriia_avl_r_size(qdriia_avl_r_size),        		  //.burstcount
		.qdriia_avl_r_rdata_valid(qdriia_avl_r_rdata_valid), //.readdatavalid
		.qdriia_avl_r_rdata(qdriia_avl_r_rdata),             //.readdata
		
		.qdriia_local_init_done(qdriia_local_init_done),     // status.local_init_done
		.qdriia_local_cal_success(qdriia_local_cal_success), //.local_cal_success
		.qdriia_local_cal_fail(qdriia_local_cal_fail),       //.local_cal_fail

	// QDRII+ SRAM (B)
		.qdriib_mem_cq_n(QDRIIB_CQ_n),                       // memory.mem_cq_n
		.qdriib_mem_wps_n(QDRIIB_WPS_n),                     //.mem_wps_n
		.qdriib_mem_cq(QDRIIB_CQ_p),                   		  //.mem_cq
		.qdriib_mem_rps_n(QDRIIB_RPS_n),                     //.mem_rps_n
		.qdriib_mem_a(QDRIIB_A),                    			  //.mem_a
		.qdriib_mem_d(QDRIIB_D),                             //.mem_d
		.qdriib_mem_k_n(QDRIIB_K_n),                         //.mem_k_n
		.qdriib_mem_bws_n(QDRIIB_BWS_n),                     //.mem_bws_n
		.qdriib_mem_q(QDRIIB_Q),                             //.mem_q
		.qdriib_mem_k(QDRIIB_K_p),                           //.mem_k
		.qdriib_mem_doff_n(QDRIIB_DOFF_n),                   //.mem_doff_n
		
		.qdriib_avl_w_write_req(qdriib_avl_w_write_req),     // avl_w.write
		.qdriib_avl_w_ready(qdriib_avl_w_ready),             //.waitrequest_n
		.qdriib_avl_w_addr(qdriib_avl_w_addr),               //.address
		.qdriib_avl_w_size(qdriib_avl_w_size),               //.burstcount
		.qdriib_avl_w_wdata(qdriib_avl_w_wdata),             //.writedata
		.qdriib_avl_r_read_req(qdriib_avl_r_read_req),       // avl_r.read
		.qdriib_avl_r_ready(qdriib_avl_r_ready),             //.waitrequest_n
		.qdriib_avl_r_addr(qdriib_avl_r_addr),               //.address
		.qdriib_avl_r_size(qdriib_avl_r_size),               //.burstcount
		.qdriib_avl_r_rdata_valid(qdriib_avl_r_rdata_valid), //.readdatavalid
		.qdriib_avl_r_rdata(qdriib_avl_r_rdata),             //.readdata
		
		.qdriib_local_init_done(qdriib_local_init_done),     // status.local_init_done
		.qdriib_local_cal_success(qdriib_local_cal_success), //.local_cal_success
		.qdriib_local_cal_fail(qdriib_local_cal_fail),       //.local_cal_fail
	
	// QDRII+ SRAM (C)
		.qdriic_mem_cq_n(QDRIIC_CQ_n),                       // memory.mem_cq_n
		.qdriic_mem_wps_n(QDRIIC_WPS_n),                     //.mem_wps_n
		.qdriic_mem_cq(QDRIIC_CQ_p),                         //.mem_cq
		.qdriic_mem_rps_n(QDRIIC_RPS_n),                     //.mem_rps_n
		.qdriic_mem_a(QDRIIC_A),                             //.mem_a
		.qdriic_mem_d(QDRIIC_D),                             //.mem_d
		.qdriic_mem_k_n(QDRIIC_K_n),                         //.mem_k_n
		.qdriic_mem_bws_n(QDRIIC_BWS_n),                     //.mem_bws_n
		.qdriic_mem_q(QDRIIC_Q),                             //.mem_q
		.qdriic_mem_k(QDRIIC_K_p),                           //.mem_k
		.qdriic_mem_doff_n(QDRIIC_DOFF_n),                   //.mem_doff_n
		
		.qdriic_avl_w_write_req(qdriic_avl_w_write_req),     // avl_w.write
		.qdriic_avl_w_ready(qdriic_avl_w_ready),             //.waitrequest_n
		.qdriic_avl_w_addr(qdriic_avl_w_addr),               //.address
		.qdriic_avl_w_size(qdriic_avl_w_size),               //.burstcount
		.qdriic_avl_w_wdata(qdriic_avl_w_wdata),             //.writedata
		.qdriic_avl_r_read_req(qdriic_avl_r_read_req),       // avl_r.read
		.qdriic_avl_r_ready(qdriic_avl_r_ready),             //.waitrequest_n
		.qdriic_avl_r_addr(qdriic_avl_r_addr),               //.address
		.qdriic_avl_r_size(qdriic_avl_r_size),               //.burstcount
		.qdriic_avl_r_rdata_valid(qdriic_avl_r_rdata_valid), //.readdatavalid
		.qdriic_avl_r_rdata(qdriic_avl_r_rdata),             //.readdata
		
		.qdriic_local_init_done(qdriic_local_init_done),     // status.local_init_done
		.qdriic_local_cal_success(qdriic_local_cal_success), //.local_cal_success
		.qdriic_local_cal_fail(qdriic_local_cal_fail),       //.local_cal_fail
	
	// QDRII+ SRAM (D)
		.qdriid_mem_cq_n(QDRIID_CQ_n),                       // memory.mem_cq_n
		.qdriid_mem_wps_n(QDRIID_WPS_n),                     //.mem_wps_n
		.qdriid_mem_cq(QDRIID_CQ_p),                         //.mem_cq
		.qdriid_mem_rps_n(QDRIID_RPS_n),                     //.mem_rps_n
		.qdriid_mem_a(QDRIID_A),                             //.mem_a
		.qdriid_mem_d(QDRIID_D),                             //.mem_d
		.qdriid_mem_k_n(QDRIID_K_n),                         //.mem_k_n
		.qdriid_mem_bws_n(QDRIID_BWS_n),                     //.mem_bws_n
		.qdriid_mem_q(QDRIID_Q),                             //.mem_q
		.qdriid_mem_k(QDRIID_K_p),                           //.mem_k
		.qdriid_mem_doff_n(QDRIID_DOFF_n),                   //.mem_doff_n
		
		.qdriid_avl_w_write_req(qdriid_avl_w_write_req),     // avl_w.write
		.qdriid_avl_w_ready(qdriid_avl_w_ready),             //.waitrequest_n
		.qdriid_avl_w_addr(qdriid_avl_w_addr),               //.address
		.qdriid_avl_w_size(qdriid_avl_w_size),               //.burstcount
		.qdriid_avl_w_wdata(qdriid_avl_w_wdata),             //.writedata
		.qdriid_avl_r_read_req(qdriid_avl_r_read_req),       // avl_r.read
		.qdriid_avl_r_ready(qdriid_avl_r_ready),             //.waitrequest_n
		.qdriid_avl_r_addr(qdriid_avl_r_addr),               //.address
		.qdriid_avl_r_size(qdriid_avl_r_size),               //.burstcount
		.qdriid_avl_r_rdata_valid(qdriid_avl_r_rdata_valid), //.readdatavalid
		.qdriid_avl_r_rdata(qdriid_avl_r_rdata),             //.readdata
		
		.qdriid_local_init_done(qdriid_local_init_done),     // status.local_init_done
		.qdriid_local_cal_success(qdriid_local_cal_success), //.local_cal_success
		.qdriid_local_cal_fail(qdriid_local_cal_fail)        //.local_cal_fail
    );

assign QDRIIA_ODT = 1'b0;
assign QDRIIB_ODT = 1'b0;
assign QDRIIC_ODT = 1'b0;
assign QDRIID_ODT = 1'b0;


/////////////////// QDRII+ SRAM (A) Test ///////////////////
wire        qdriia_avl_w_write_req;           				 // qdriia_avl_w.write
wire        qdriia_avl_w_ready;               				 //.waitrequest_n
wire [19:0] qdriia_avl_w_addr;                				 //.address
wire [2:0]  qdriia_avl_w_size;                				 //.burstcount
wire [71:0] qdriia_avl_w_wdata;                				 //.writedata
wire        qdriia_avl_r_read_req;             				 // qdriia_avl_r.read
wire        qdriia_avl_r_ready;               				 //.waitrequest_n
wire [19:0] qdriia_avl_r_addr;                				 //.address
wire [2:0]  qdriia_avl_r_size;                 				 //.burstcount
wire        qdriia_avl_r_rdata_valid;          				 //.readdatavalid
wire [71:0] qdriia_avl_r_rdata;               				 //.readdata

wire			qdriia_local_ready;
assign      qdriia_local_ready = (qdriia_avl_w_write_req) ? qdriia_avl_w_ready : qdriia_avl_r_ready;

wire [19:0] qdriia_avl_addr;        							 //.address
assign qdriia_avl_w_addr = qdriia_avl_addr;
assign qdriia_avl_r_addr = qdriia_avl_addr;

assign qdriia_avl_w_size = 1;		
assign qdriia_avl_r_size = 1;

Avalon_bus_RW_Test QDRII_A_VERIFY(

		.iCLK(afi_clk),
		.iRST_n(test_software_reset_n),
		.iBUTTON(test_start_n),

		.local_init_done(qdriia_local_init_done),
		.avl_waitrequest_n(qdriia_local_ready),                 
		.avl_address(qdriia_avl_addr),                     
		.avl_readdatavalid(qdriia_avl_r_rdata_valid),                 
		.avl_readdata(qdriia_avl_r_rdata),                      
		.avl_writedata(qdriia_avl_w_wdata),                     
		.avl_read(qdriia_avl_r_read_req),                          
		.avl_write(qdriia_avl_w_write_req),    
		.avl_burstbegin(),
		
		.drv_status_pass(qdriia_pass),
		.drv_status_fail(qdriia_fail),
		.drv_status_test_complete(qdriia_test_complete)

);	

/////////////////// QDRII+ SRAM (B) Test ///////////////////
wire        qdriib_avl_w_write_req;                       // qdriib_avl_w.write
wire        qdriib_avl_w_ready;                           //.waitrequest_n
wire [19:0] qdriib_avl_w_addr;                            //.address
wire [2:0]  qdriib_avl_w_size;                            //.burstcount
wire [71:0] qdriib_avl_w_wdata;                           //.writedata
wire        qdriib_avl_r_read_req;                        // qdriib_avl_r.read
wire        qdriib_avl_r_ready;                           //.waitrequest_n
wire [19:0] qdriib_avl_r_addr;                            //.address
wire [2:0]  qdriib_avl_r_size;                            //.burstcount
wire        qdriib_avl_r_rdata_valid;                     //.readdatavalid
wire [71:0] qdriib_avl_r_rdata;                           //.readdata

wire			qdriib_local_ready;
assign      qdriib_local_ready = (qdriib_avl_w_write_req) ? qdriib_avl_w_ready : qdriib_avl_r_ready;

wire [19:0] qdriib_avl_addr;        							 //.address
assign qdriib_avl_w_addr = qdriib_avl_addr;
assign qdriib_avl_r_addr = qdriib_avl_addr;

assign qdriib_avl_w_size = 1;		
assign qdriib_avl_r_size = 1;

Avalon_bus_RW_Test QDRII_B_VERIFY(

		.iCLK(afi_clk),
		.iRST_n(test_software_reset_n),
		.iBUTTON(test_start_n),

		.local_init_done(qdriib_local_init_done),
		.avl_waitrequest_n(qdriib_local_ready),                 
		.avl_address(qdriib_avl_addr),                     
		.avl_readdatavalid(qdriib_avl_r_rdata_valid),                 
		.avl_readdata(qdriib_avl_r_rdata),                      
		.avl_writedata(qdriib_avl_w_wdata),                     
		.avl_read(qdriib_avl_r_read_req),                          
		.avl_write(qdriib_avl_w_write_req),    
		.avl_burstbegin(),

		.drv_status_pass(qdriib_pass),
		.drv_status_fail(qdriib_fail),
		.drv_status_test_complete(qdriib_test_complete)

);	

/////////////////// QDRII+ SRAM (C) Test ///////////////////
wire        qdriic_avl_w_write_req;              			 // qdriic_avl_w.write
wire        qdriic_avl_w_ready;                				 //.waitrequest_n
wire [19:0] qdriic_avl_w_addr;                  			 //.address
wire [2:0]  qdriic_avl_w_size;                 				 //.burstcount
wire [71:0] qdriic_avl_w_wdata;                				 //.writedata
wire        qdriic_avl_r_read_req;             				 // qdriic_avl_r.read
wire        qdriic_avl_r_ready;                				 //.waitrequest_n
wire [19:0] qdriic_avl_r_addr;                 				 //.address
wire [2:0]  qdriic_avl_r_size;                 				 //.burstcount
wire        qdriic_avl_r_rdata_valid;          				 //.readdatavalid
wire [71:0] qdriic_avl_r_rdata;                				 //.readdata

wire			qdriic_local_ready;
assign      qdriic_local_ready = (qdriic_avl_w_write_req) ? qdriic_avl_w_ready : qdriic_avl_r_ready;

wire [19:0] qdriic_avl_addr;        							 //.address
assign qdriic_avl_w_addr = qdriic_avl_addr;
assign qdriic_avl_r_addr = qdriic_avl_addr;

assign qdriic_avl_w_size = 1;		
assign qdriic_avl_r_size = 1;

Avalon_bus_RW_Test QDRII_C_VERIFY(

		.iCLK(afi_clk),
		.iRST_n(test_software_reset_n),
		.iBUTTON(test_start_n),

		.local_init_done(qdriic_local_init_done),
		.avl_waitrequest_n(qdriic_local_ready),                 
		.avl_address(qdriic_avl_addr),                     
		.avl_readdatavalid(qdriic_avl_r_rdata_valid),                 
		.avl_readdata(qdriic_avl_r_rdata),                      
		.avl_writedata(qdriic_avl_w_wdata),                     
		.avl_read(qdriic_avl_r_read_req),                          
		.avl_write(qdriic_avl_w_write_req),    
		.avl_burstbegin(),

		.drv_status_pass(qdriic_pass),
		.drv_status_fail(qdriic_fail),
		.drv_status_test_complete(qdriic_test_complete)
);	

/////////////////// QDRII+ SRAM (D) Test    ///////////////////
wire        qdriid_avl_w_write_req;            					 // qdriid_avl_w.write
wire        qdriid_avl_w_ready;                					 //.waitrequest_n
wire [19:0] qdriid_avl_w_addr;                 					 //.address
wire [2:0]  qdriid_avl_w_size;                 					 //.burstcount
wire [71:0] qdriid_avl_w_wdata;                					 //.writedata
wire        qdriid_avl_r_read_req;             					 // qdriid_avl_r.read
wire        qdriid_avl_r_ready;                					 //.waitrequest_n
wire [19:0] qdriid_avl_r_addr;                					 //.address
wire [2:0]  qdriid_avl_r_size;                					 //.burstcount
wire        qdriid_avl_r_rdata_valid;         					 //.readdatavalid
wire [71:0] qdriid_avl_r_rdata;               					 //.readdata

wire			qdriid_local_ready;
assign      qdriid_local_ready = (qdriid_avl_w_write_req) ? qdriid_avl_w_ready : qdriid_avl_r_ready;

wire [19:0] qdriid_avl_addr;        								 //.address
assign qdriid_avl_w_addr = qdriid_avl_addr;
assign qdriid_avl_r_addr = qdriid_avl_addr;

assign qdriid_avl_w_size = 1;		
assign qdriid_avl_r_size = 1;

Avalon_bus_RW_Test QDRII_D_VERIFY(

		.iCLK(afi_clk),
		.iRST_n(test_software_reset_n),
		.iBUTTON(test_start_n),

		.local_init_done(qdriid_local_init_done),
		.avl_waitrequest_n(qdriid_local_ready),                 
		.avl_address(qdriid_avl_addr),                     
		.avl_readdatavalid(qdriid_avl_r_rdata_valid),                 
		.avl_readdata(qdriid_avl_r_rdata),                      
		.avl_writedata(qdriid_avl_w_wdata),                     
		.avl_read(qdriid_avl_r_read_req),                          
		.avl_write(qdriid_avl_w_write_req),    
		.avl_burstbegin(),

		.drv_status_pass(qdriid_pass),
		.drv_status_fail(qdriid_fail),
		.drv_status_test_complete(qdriid_test_complete)
);	


//////////////////////////////////////////////
// reset_n and start_n control
reg [31:0]  cont;
always@(posedge OSC_50_B3B)
cont<=(cont==32'd2000001)?32'd0:cont+1'b1;

reg[4:0] sample;
always@(posedge OSC_50_B3B)
begin
	if(cont==32'd2000000)
		sample[4:0]={sample[3:0],BUTTON[0]};
	else 
		sample[4:0]=sample[4:0];
end

assign test_software_reset_n =(sample[1:0]==2'b10)?1'b0:1'b1;
assign test_global_reset_n   =(sample[3:2]==2'b10)?1'b0:1'b1;
assign test_start_n          =(sample[4:3]==2'b01)?1'b0:1'b1;

assign LED = {~qdriid_pass,~qdriic_pass,~qdriib_pass,~qdriia_pass};


endmodule